#include <test/lib/test/PIdentitySetBucketTest.h>

// Auto generated Tests from PIdentitySetBucketTest

// Test Object to put test methods into 
Type_Class AutoGenTest_TestCase_Class;
Object AutoGenTest_test_Class_Instance;
// Test Method symbol 
Type_Symbol PIdentitySetBucketTest_SMB_runTestCase;


/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testIncludesMixed)
/*
testIncludesMixed
// 	(b includes: #key) should = false.
// 	b add: #key.
// 	(b includes: #key) should = true.
// 	(b includes: 'key') should = false.
// 	(b includes: #key2) should = false.
// 	b add: 'key2'.
// 	(b includes: #key) should = true.
// 	(b includes: 'key') should = false.
// 	(b includes: #key2) should = false.
// 	b add: #key2.
// 	
// 	PParallelDebugger interpret:
//     		(Array
//         		with: [b includes: #key ]
//         		with: [b includes: 'key'])
// 
*/
Object symbol7574 = (Object)new_Type_Symbol_cached(L"testIncludesMixed");
// testIncludesMixed. 
Object send41137 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7574, 0);
Eval((Object)send41137);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testAddUnique)
/*
testAddUnique
// 	b bucketSize should = 0.
// 	b add: #key.
// 	b bucketSize should = 1.
// 	b add: #key.
// 	b bucketSize should = 1.
// 	b add: 'key2'.
// 	b bucketSize should = 2
*/
Object symbol7576 = (Object)new_Type_Symbol_cached(L"testAddUnique");
// testAddUnique. 
Object send41138 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7576, 0);
Eval((Object)send41138);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testAddMixed)
/*
testAddMixed
// 	b bucketSize should = 0.
// 	b add: #key.
// 	b bucketSize should = 1.
// 	b add: #key.
// 	b bucketSize should = 1.
// 	b add: 'key'.
// 	b bucketSize should = 2.
// 	b add: 'key2'.
// 	b bucketSize should = 3
*/
Object symbol7577 = (Object)new_Type_Symbol_cached(L"testAddMixed");
// testAddMixed. 
Object send41139 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7577, 0);
Eval((Object)send41139);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testIsFull)
/*
testIsFull
// 	b := PSetBucket new: 3.
// 	b isFull should = false.
// 	b add: #a.
// 	b add: #b.
// 	b isFull should = false.
// 	b add: #c.
// 	b isFull should = true.
// 	b remove: #b.
// 	b isFull should = false
*/
Object symbol7578 = (Object)new_Type_Symbol_cached(L"testIsFull");
// testIsFull. 
Object send41140 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7578, 0);
Eval((Object)send41140);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testRemove)
/*
testRemove
// 	b bucketSize should = 0.
// 	b add: #key1.
// 	b add: #key2.
// 	b add: #key3.
// 	b bucketSize should = 3.
// 	b remove: #key2.
// 	b bucketSize should = 2.
// 	b remove: #key1.
// 	b bucketSize should = 1.
// 	b remove: #key3.
// 	b bucketSize should = 0
*/
Object symbol7579 = (Object)new_Type_Symbol_cached(L"testRemove");
// testRemove. 
Object send41141 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7579, 0);
Eval((Object)send41141);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testDo)
/*
testDo
// 	| c |
// 	c := OrderedCollection new.
// 	b do: [ :each | c add: each ].
// 	c size should = 0.
// 	b add: #a.
// 	b add: #b.
// 	b add: #c.
// 	b do: [ :each | c add: each ].
// 	c size should = 3
*/
Object symbol7582 = (Object)new_Type_Symbol_cached(L"testDo");
// testDo. 
Object send41142 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7582, 0);
Eval((Object)send41142);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testValueIndexDo)
/*
testValueIndexDo
// 	| c |
// 	c := OrderedCollection new.
// 	b
// 		valueIndexDo:
// 			[ :value :index | 
// 			c
// 				add: value;
// 				add: index ].
// 	c size should = 0.
// 	b add: #a.
// 	b add: #b.
// 	b add: #c.
// 	b
// 		valueIndexDo:
// 			[ :value :index | 
// 			c
// 				add: value;
// 				add: index ].
// 	c size should = 6
*/
Object symbol7583 = (Object)new_Type_Symbol_cached(L"testValueIndexDo");
// testValueIndexDo. 
Object send41143 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7583, 0);
Eval((Object)send41143);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testIncludesUnique)
/*
testIncludesUnique
// 	(b includes: #key) should = false.
// 	b add: #key.
// 	(b includes: #key) should = true.
// 	(b includes: #key2) should = false.
// 	b add: 'key2'.
// 	(b includes: #key) should = true.
// 	(b includes: 'key2') should = true
*/
Object symbol7584 = (Object)new_Type_Symbol_cached(L"testIncludesUnique");
// testIncludesUnique. 
Object send41144 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7584, 0);
Eval((Object)send41144);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testRemoveIfAbsent)
/*
testRemoveIfAbsent
// 	(b remove: #v ifAbsent: [ 1 ]) should = 1.
// 	b add: #v.
// 	(b remove: #v ifAbsent: [ 1 ]) should = #v
*/
Object symbol7585 = (Object)new_Type_Symbol_cached(L"testRemoveIfAbsent");
// testRemoveIfAbsent. 
Object send41145 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7585, 0);
Eval((Object)send41145);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */

NEW_TEST(PIdentitySetBucketTest_testIsEmpty)
/*
testIsEmpty
// 	b isEmpty should = true.
// 	b add: #v.
// 	b isEmpty should = false.
// 	b remove: #v.
// 	b isEmpty should = true
*/
Object symbol7587 = (Object)new_Type_Symbol_cached(L"testIsEmpty");
// testIsEmpty. 
Object send41146 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7587, 0);
Eval((Object)send41146);
ASSERT_EMPTY_STACK
}

/* ========================================================================= */


void PIdentitySetBucketTest_setUp() {
Object symbol7238 = (Object)new_Type_Symbol_cached(L"setUp");
// setUp. 
Object send41147 = (Object)new_AST_Send((Object)AutoGenTest_test_Class_Instance, (Object)symbol7238, 0);
Eval((Object)send41147);
}

TEST_SUITE(PIdentitySetBucketTest,
{
    AutoGenTest_TestCase_Class =(Type_Class)PIdentitySetBucketTest;
    AutoGenTest_test_Class_Instance =(Object)new_AST_Constant((Object)instantiate((Type_Class)AutoGenTest_TestCase_Class));

    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testIncludesMixed);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testAddUnique);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testAddMixed);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testIsFull);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testRemove);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testDo);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testValueIndexDo);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testIncludesUnique);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testRemoveIfAbsent);
    PIdentitySetBucketTest_setUp();
    RUN_TEST(PIdentitySetBucketTest_testIsEmpty);
})